/**
 * @file generate.h Base generation functions
 * 
 * $Id: generate.h,v 1.6 2001/12/31 09:26:54 chipx86 Exp $
 *
 * @Copyright (C) 2000-2002 The GNUpdate Project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 */
#ifndef _GENST_GENERATE_H_
#define _GENST_GENERATE_H_

#include "genst.h"

/*
 * #include "dialog.h"
 * #include "projectinfo.h"
 */

typedef struct
{
	Gauge *gauge;
	
	int totalSteps;
	int currentPercent;
	int percentIncrement;

} GenerationState;

void updateGenerationStatus(GenerationState *state,
							const char *baseMessage,
							const char *specific);

void generate(ProjectInfo *project);
void generateDirectories(ProjectInfo *project, GenerationState *state);
void generateDocumentation(ProjectInfo *project, GenerationState *state);
void generateAutogen(ProjectInfo *project, GenerationState *state);
void generateConfigureIn(ProjectInfo *project, GenerationState *state);
void generateAcconfig(ProjectInfo *project, GenerationState *state);
void generateMacros(ProjectInfo *project, GenerationState *state);
void generateMakefiles(ProjectInfo *project, GenerationState *state);
void generateLibConfig(ProjectInfo *project, GenerationState *state);
void generateM4(ProjectInfo *project, GenerationState *state);
void generateRpmSpec(ProjectInfo *project, GenerationState *state);

#endif /* _GENST_GENERATE_H_ */
