/**
 * @file generateDirectories.c Directory generation
 * 
 * $Id: generate_dirs.c,v 1.8 2001/12/31 09:26:55 chipx86 Exp $
 *
 * @Copyright (C) 2000-2002 The GNUpdate Project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 */
#include "genst.h"

void
generateDirectories(ProjectInfo *project, GenerationState *state)
{
	char baseMessage[26] = "Creating directories:\n\t";
	
	/* Base directory */
	updateGenerationStatus(state, baseMessage, project->dir);
	mkdir(project->dir, 0755);

	/* src directory */
	if (project->target == TARGET_EXECUTABLE || project->target == TARGET_BOTH)
	{
		char *dir = (char *)malloc((strlen(project->dir) + 5) * sizeof(char));

		strcpy(dir, project->dir);
		strcat(dir, "/src");

		updateGenerationStatus(state, baseMessage, dir);
		mkdir(dir, 0755);

		free(dir);
	}

	/* lib directory */
	if (project->target == TARGET_LIBRARY || project->target == TARGET_BOTH)
	{
		char *dir = (char *)malloc((strlen(project->dir) +
									strlen(project->name) + 5) *
								   sizeof(char));

		strcpy(dir, project->dir);
		strcat(dir, "/lib");
		strcat(dir, project->name);

		updateGenerationStatus(state, baseMessage, dir);
		mkdir(dir, 0755);

		free(dir);
	}
}

