/**
 * @file projectinfo.h Project information
 * 
 * $Id: projectinfo.h,v 1.7 2001/12/31 09:26:55 chipx86 Exp $
 *
 * @Copyright (C) 2000-2002 The GNUpdate Project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 */
#ifndef _GENST_PROJECTINFO_H_
#define _GENST_PROJECTINFO_H_

#include "genst.h"
/* #include "package.h" */

typedef enum
{
	TARGET_EXECUTABLE,
	TARGET_LIBRARY,
	TARGET_BOTH

} Targets;

typedef struct
{
	char c;
	char cpp;
	char fortran;
	char yacc;
	char lex;
	char awk;

} Languages;

typedef struct
{
	char *name;
	char *version;
	char *license;
	char *summary;
	char *group;
	char *dir;
	char *lang;

	Targets target;
	Languages *languages;

	Package *packages;
	Package *lastPackage;

} ProjectInfo;

ProjectInfo *newProjectInfo();
void freeProjectInfo(ProjectInfo *project);
int getProjectPackagesCount(ProjectInfo *project);
Package *getPackageWithName(ProjectInfo *project, const char *name);

void requestProjectName(ProjectInfo *project);
void requestProjectVersion(ProjectInfo *project);
void requestProjectLicense(ProjectInfo *project);
void requestProjectSummary(ProjectInfo *project);
void requestProjectGroup(ProjectInfo *project);
void requestProjectLanguage(ProjectInfo *project);
void requestProjectDirectory(ProjectInfo *project);
void requestProjectTarget(ProjectInfo *project);
void requestPackages(ProjectInfo *project);
void requestChecks(ProjectInfo *project, const char *packageName);

#endif /* _GENST_PROJECTINFO_H_ */
