/**
 * @file utils.h Utility functions
 * 
 * $Id: utils.h,v 1.6 2001/12/31 09:26:55 chipx86 Exp $
 *
 * @Copyright (C) 2000-2002 The GNUpdate Project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 */
#ifndef _GENST_UTILS_H_
#define _GENST_UTILS_H_

int getCharCount(const char *chars, char c);
int charsToArray(const char *chars, char ***result);
char isWhitespace(const char *chars);
char isMenuSep(const char *item);
char inArray(const char **array, const char *item, int arraySize);

char fileExists(const char *filename);
void touchFile(const char *dir, const char *filename);
void copyFile(const char *srcfile, const char *destfile);
void appendFile(const char *srcfile, const char *destfile);

char *stringToUpper(const char *str);

char *fixProjectName(const char *str);

void setCurrentProject(ProjectInfo *project);
ProjectInfo *getCurrentProject();

char confirmQuit();
void quit();

#endif /* _GENST_UTILS_H_ */
